KEY_CHAIN=build.keychain
CERTIFICATE=certificate.cer

# Recreate the certificate from the secure environment variable
echo $MACOS_CERT_FILE | base64 --decode > $CERTIFICATE

#create a keychain
security create-keychain -p travis $KEY_CHAIN

# Make the keychain the default so identities are found
security default-keychain -s $KEY_CHAIN

# Unlock the keychain
security unlock-keychain -p travis $KEY_CHAIN

security import $CERTIFICATE -k $KEY_CHAIN  -T /usr/bin/codesign;

security find-identity -v

security set-key-partition-list -S apple-tool:,apple: -s -k travis $KEY_CHAIN

# remove certs
rm -fr *.cer