"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
exports.__esModule = true;
var electron_1 = require("electron");
var path = require("path");
var isDev = require("electron-is-dev");
var electron_log_1 = require("electron-log");
var electron_devtools_installer_1 = require("electron-devtools-installer");
var config = require("./config.json");
var services_1 = require("./services");
var oauth2_manager_1 = require("./services/oauth2-manager");
var api_klink_manager_1 = require("./services/api-klink-manager");
var api_notifications_manager_1 = require("./services/api-notifications-manager");
electron_log_1["default"].info('[App] Starting application');
if (process.platform === 'win32' && isDev) {
    electron_1.app.setAppUserModelId(process.execPath);
}
// Handle creating/removing shortcuts on Windows when installing/uninstalling.
if (require('electron-squirrel-startup')) {
    electron_1.app.quit();
}
var closeWindows = function () {
    electron_log_1["default"].info('[App] Closing existing windows');
    electron_1.BrowserWindow.getAllWindows().forEach(function (window) {
        if (window.isClosable()) {
            window.close();
        }
    });
};
var targetManager = new services_1.TargetManager();
var authManager = new services_1.AuthManager();
var klinkManager = new services_1.KlinkManager(authManager);
var notificationsManager = new services_1.NotificationsManager(authManager);
var createWindow = function () { return __awaiter(void 0, void 0, void 0, function () {
    var window, url;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!oauth2_manager_1.shouldRefreshTokens()) return [3 /*break*/, 2];
                return [4 /*yield*/, oauth2_manager_1.refreshTokens()];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2:
                closeWindows();
                electron_log_1["default"].info('[App] Creating application window');
                window = new electron_1.BrowserWindow({
                    width: 800,
                    height: 600,
                    skipTaskbar: true,
                    webPreferences: {
                        preload: path.join(__dirname, './preload.js'),
                        disableBlinkFeatures: 'Auxclick',
                        contextIsolation: true,
                        sandbox: true
                    },
                    show: false
                });
                window.on('ready-to-show', function () {
                    window.show();
                });
                url = isDev
                    ? 'http://localhost:3000'
                    : "file://" + path.join(__dirname, '../../build/index.html');
                window.loadURL(url);
                if (isDev) {
                    window.webContents.openDevTools({
                        mode: 'detach'
                    });
                }
                return [2 /*return*/];
        }
    });
}); };
electron_1.app.on('open-url', function (event, url) { return __awaiter(void 0, void 0, void 0, function () {
    var hostname;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                event.preventDefault();
                electron_log_1["default"].info("[App] Opening custom protocol URL: " + url);
                hostname = new URL(url).hostname;
                targetManager.setTarget("/klink/" + hostname);
                if (!electron_1.app.isReady()) return [3 /*break*/, 2];
                return [4 /*yield*/, createWindow()];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2: return [2 /*return*/];
        }
    });
}); });
if (process.platform === 'win32') {
    var url = process.argv.pop();
    if (url && url.startsWith('klink://')) {
        electron_log_1["default"].info("[App] Opening custom protocol URL: " + url);
        var hostname = new URL(url).hostname;
        targetManager.setTarget("/klink/" + hostname);
    }
}
var gotTheLock = electron_1.app.requestSingleInstanceLock();
if (!gotTheLock) {
    electron_1.app.quit();
    electron_log_1["default"].error('[App] Failed second instance lock');
    process.exit(0);
}
else {
    electron_log_1["default"].info('[App] Got second instance lock');
    var tray_1;
    var onAppIsReadyNotification = function () {
        new electron_1.Notification({
            title: 'Klink App',
            body: 'Klink App is ready'
        }).show();
    };
    electron_1.app
        .whenReady()
        .then(onAppIsReadyNotification)
        .then(function () { return __awaiter(void 0, void 0, void 0, function () {
        var shortcutRegistered, buildContextMenu;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    electron_log_1["default"].info('[App] Application ready');
                    shortcutRegistered = electron_1.globalShortcut.register(config.SHORTCUT_CREATE_KLINK, function () {
                        targetManager.setTarget(null);
                        createWindow();
                    });
                    if (!shortcutRegistered) {
                        electron_log_1["default"].error('[App] Failed registering shortcut');
                    }
                    if (electron_1.app.isDefaultProtocolClient('klink')) {
                        electron_1.app.removeAsDefaultProtocolClient('klink');
                    }
                    if (isDev && process.platform === 'win32') {
                        // Set the path of electron.exe and your app.
                        // These two additional parameters are only available on windows.
                        // Setting this is required to get this working in dev mode.
                        electron_1.app.setAsDefaultProtocolClient('klink', process.execPath, [
                            path.resolve(process.argv[1] || ''),
                        ]);
                    }
                    else {
                        electron_1.app.setAsDefaultProtocolClient('klink');
                    }
                    if (isDev) {
                        electron_devtools_installer_1["default"](electron_devtools_installer_1.REACT_DEVELOPER_TOOLS);
                    }
                    if (!oauth2_manager_1.shouldRefreshTokens()) return [3 /*break*/, 2];
                    return [4 /*yield*/, oauth2_manager_1.refreshTokens()];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    buildContextMenu = function () {
                        var authMenuItems = [];
                        var user = oauth2_manager_1.getCurrentUser();
                        if (user !== null) {
                            var currentUserItem = {
                                label: "Current user: " + user.phoneNumber
                            };
                            authMenuItems.push(currentUserItem);
                            authMenuItems.push({
                                label: 'Logout',
                                click: function () {
                                    oauth2_manager_1.logout();
                                    closeWindows();
                                }
                            });
                        }
                        else {
                            authMenuItems.push({
                                label: 'Login',
                                click: function () {
                                    targetManager.setTarget('/login');
                                    createWindow();
                                }
                            });
                        }
                        return electron_1.Menu.buildFromTemplate(__spreadArray(__spreadArray([], authMenuItems), [
                            { type: 'separator' },
                            {
                                label: 'Create Klink',
                                click: function () {
                                    targetManager.setTarget(null);
                                    createWindow();
                                }
                            },
                            {
                                label: 'My Klinks',
                                click: function () {
                                    targetManager.setTarget('/my-klinks');
                                    createWindow();
                                }
                            },
                            {
                                label: 'Deklink',
                                click: function () {
                                    targetManager.setTarget('/deklink');
                                    createWindow();
                                }
                            },
                            {
                                label: 'Quit',
                                click: function () {
                                    electron_1.app.quit();
                                }
                            },
                        ]));
                    };
                    tray_1 = new electron_1.Tray(path.join(__dirname, '../../assets/icon.png'));
                    tray_1.setToolTip('Klink');
                    tray_1.setContextMenu(buildContextMenu());
                    oauth2_manager_1.onOauthChange(function () {
                        tray_1.setContextMenu(buildContextMenu());
                        electron_log_1["default"].info('[Tray] Tray menu rebuilt');
                    });
                    electron_1.app.on('second-instance', function (e, argv) { return __awaiter(void 0, void 0, void 0, function () {
                        var url, hostname;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    electron_log_1["default"].info('[App] Second instance started');
                                    if (!(process.platform !== 'darwin')) return [3 /*break*/, 2];
                                    url = argv.pop();
                                    if (!(url && url.startsWith('klink://'))) return [3 /*break*/, 2];
                                    electron_log_1["default"].info("[App] Opening custom protocol URL: " + url);
                                    hostname = new URL(url).hostname;
                                    targetManager.setTarget("/klink/" + hostname);
                                    return [4 /*yield*/, createWindow()];
                                case 1:
                                    _a.sent();
                                    _a.label = 2;
                                case 2: return [2 /*return*/];
                            }
                        });
                    }); });
                    electron_1.ipcMain.on('is-dev', function (event) {
                        event.returnValue = isDev;
                    });
                    electron_1.ipcMain.on('get-target', function (event) {
                        event.returnValue = targetManager.popTarget();
                    });
                    electron_1.ipcMain.on('get-clipboard-text', function (event) {
                        event.returnValue = electron_1.clipboard.readText();
                    });
                    electron_1.ipcMain.handle('write-clipboard-text', function (event, text) {
                        electron_1.clipboard.writeText(text);
                    });
                    electron_1.ipcMain.on('get-auth-details', function (event) { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            event.returnValue = oauth2_manager_1.getCurrentUser();
                            return [2 /*return*/];
                        });
                    }); });
                    electron_1.ipcMain.on('login', function (event, phone, password) { return __awaiter(void 0, void 0, void 0, function () {
                        var authDetails, e_1;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 2, , 3]);
                                    return [4 /*yield*/, authManager.login(phone, password)];
                                case 1:
                                    authDetails = _a.sent();
                                    event.reply('login', authDetails);
                                    return [3 /*break*/, 3];
                                case 2:
                                    e_1 = _a.sent();
                                    event.reply('login', {
                                        error: true,
                                        message: e_1.message
                                    });
                                    return [3 /*break*/, 3];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); });
                    electron_1.ipcMain.on('confirm-tfa', function (event, code) { return __awaiter(void 0, void 0, void 0, function () {
                        var e_2;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 2, , 3]);
                                    return [4 /*yield*/, authManager.confirmTfa(code)];
                                case 1:
                                    _a.sent();
                                    event.reply('confirm-tfa');
                                    return [3 /*break*/, 3];
                                case 2:
                                    e_2 = _a.sent();
                                    event.reply('confirm-tfa', {
                                        error: true,
                                        message: e_2.message
                                    });
                                    return [3 /*break*/, 3];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); });
                    electron_1.ipcMain.on('create-klink', function (event, klinkRequest) { return __awaiter(void 0, void 0, void 0, function () {
                        var token, e_3;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 2, , 3]);
                                    return [4 /*yield*/, api_klink_manager_1.createKlink(klinkRequest)];
                                case 1:
                                    token = _a.sent();
                                    event.reply('create-klink', token);
                                    return [3 /*break*/, 3];
                                case 2:
                                    e_3 = _a.sent();
                                    event.reply('create-klink', {
                                        error: true,
                                        message: e_3.message
                                    });
                                    return [3 /*break*/, 3];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); });
                    electron_1.ipcMain.on('edit-klink', function (event, token, klinkRequest) { return __awaiter(void 0, void 0, void 0, function () {
                        var e_4;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 2, , 3]);
                                    return [4 /*yield*/, api_klink_manager_1.editKlink(token, klinkRequest)];
                                case 1:
                                    _a.sent();
                                    event.reply('edit-klink');
                                    return [3 /*break*/, 3];
                                case 2:
                                    e_4 = _a.sent();
                                    event.reply('edit-klink', {
                                        error: true,
                                        message: e_4.message
                                    });
                                    return [3 /*break*/, 3];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); });
                    electron_1.ipcMain.on('read-klink', function (event, token) { return __awaiter(void 0, void 0, void 0, function () {
                        var details, e_5;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 2, , 3]);
                                    return [4 /*yield*/, api_klink_manager_1.readKlink(token)];
                                case 1:
                                    details = _a.sent();
                                    event.reply('read-klink', details);
                                    return [3 /*break*/, 3];
                                case 2:
                                    e_5 = _a.sent();
                                    event.reply('read-klink', {
                                        error: true,
                                        message: e_5.message
                                    });
                                    return [3 /*break*/, 3];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); });
                    electron_1.ipcMain.on('get-current-user-klinks', function (event, page) { return __awaiter(void 0, void 0, void 0, function () {
                        var response, e_6;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 2, , 3]);
                                    return [4 /*yield*/, api_klink_manager_1.getCurrentUserKlinks(page)];
                                case 1:
                                    response = _a.sent();
                                    event.reply('get-current-user-klinks', response);
                                    return [3 /*break*/, 3];
                                case 2:
                                    e_6 = _a.sent();
                                    event.reply('get-current-user-klinks', {
                                        error: true,
                                        message: e_6.message
                                    });
                                    return [3 /*break*/, 3];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); });
                    electron_1.ipcMain.on('generate-klink', function (event, token) { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            event.returnValue = config.KLINK_URL + "/t/" + token;
                            return [2 /*return*/];
                        });
                    }); });
                    electron_1.ipcMain.handle('close-window', function () {
                        closeWindows();
                    });
                    electron_1.ipcMain.on('login-with-kloke', function (event) { return __awaiter(void 0, void 0, void 0, function () {
                        var win_1, filter, e_7;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    closeWindows();
                                    _a.label = 1;
                                case 1:
                                    _a.trys.push([1, 3, , 4]);
                                    win_1 = new electron_1.BrowserWindow({
                                        width: 800,
                                        height: 600,
                                        show: false,
                                        webPreferences: {
                                            nodeIntegration: false
                                        }
                                    });
                                    return [4 /*yield*/, win_1.loadURL(oauth2_manager_1.getAuthenticationURL())];
                                case 2:
                                    _a.sent();
                                    win_1.show();
                                    filter = {
                                        urls: [config.REDIRECT_URI + "*"]
                                    };
                                    win_1.webContents.session.webRequest.onBeforeRequest(filter, function (_a) {
                                        var url = _a.url;
                                        return __awaiter(void 0, void 0, void 0, function () {
                                            return __generator(this, function (_b) {
                                                switch (_b.label) {
                                                    case 0: return [4 /*yield*/, oauth2_manager_1.loadTokens(url)];
                                                    case 1:
                                                        _b.sent();
                                                        win_1.close();
                                                        return [2 /*return*/];
                                                }
                                            });
                                        });
                                    });
                                    win_1.on('closed', function () {
                                        win_1 = null;
                                    });
                                    return [3 /*break*/, 4];
                                case 3:
                                    e_7 = _a.sent();
                                    event.reply('login-with-kloke', {
                                        error: true,
                                        message: e_7.messsage
                                    });
                                    return [3 /*break*/, 4];
                                case 4: return [2 /*return*/];
                            }
                        });
                    }); });
                    return [4 /*yield*/, api_notifications_manager_1.registerPushy(function (message) {
                            var notification = new electron_1.Notification({
                                title: 'Message was read',
                                body: "\"" + message.title + "\" was read by " + message.reader
                            });
                            notification.on('click', function () {
                                targetManager.setTarget("/klink/" + message.token);
                                createWindow();
                            });
                            notification.show();
                        })];
                case 3:
                    _a.sent();
                    if (!targetManager.hasTarget()) return [3 /*break*/, 5];
                    return [4 /*yield*/, createWindow()];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5: return [2 /*return*/];
            }
        });
    }); });
    //TODO: add oauth2 API to permissions
    // app.on('web-contents-created', (event, contents) => {
    //   log.info(`[App] New window contents created: ${contents.getType()}`)
    //   // Block non-JS navigation https://github.com/doyensec/electronegativity/wiki/LIMIT_NAVIGATION_JS_CHECK
    //   contents.on('will-navigate', (event) => {
    //     event.preventDefault()
    //   })
    //   contents.setWindowOpenHandler(() => {
    //     return { action: 'deny' }
    //   })
    //   // Block all browser APIs https://github.com/doyensec/electronegativity/wiki/PERMISSION_REQUEST_HANDLER_JS_CHECK
    //   contents.session.setPermissionRequestHandler((webContents, permission, callback) => {
    //     return callback(false)
    //   })
    // })
    electron_1.app.on('window-all-closed', function () {
        electron_log_1["default"].info('[App] All windows closed');
    });
}
//# sourceMappingURL=main.js.map