import Dexie, { Table } from 'dexie'
import {Contact} from '../../types'

const DATABASE_NAME = 'klink'
const DATABASE_VERSION = 1
const DATABASE_SCHEMA = {
  contacts: '++id, name, &phone',
}

class KlinkDatabase extends Dexie {
  contacts: Table<Contact, number>

  constructor() {
    super(DATABASE_NAME)

    this.version(DATABASE_VERSION).stores(DATABASE_SCHEMA)

    this.contacts = this.table('contacts')
  }
}

const db = new KlinkDatabase()

export default db
